from common import Constants
import exception.MyErrorException as ex

# 写出到 MySQL
from sources import Sources


def sinkMySql(sinkDF, driver, url, user, password, table, mode=Constants.SAVE_MODE_OVERWRITE):
    sinkDF.write.mode(mode) \
        .format("jdbc") \
        .option("truncate", "true") \
        .option("batchsize", 10000) \
        .option("isolationLevel", "NONE") \
        .option("driver", driver) \
        .option("url", url) \
        .option("user", user) \
        .option("password", password) \
        .option("dbtable", table) \
        .save()

# 写出到FTP
'''
相关参数, 例如: 
   host: 192.168.31.45
   username: raomin@9zdata.cn
   password: 9zdata123.
   fileType: csv
   file: ftp://192.168.31.45:21/wanjia/sample.csv
'''
def sinkFTP(sinkDF, host, user, password, filetype, file, delimiter):
    sinkDF.write.format("com.springml.spark.sftp")  \
        .option("host", host) \
        .option("username", user) \
        .option("password", password) \
        .option("fileType", filetype) \
        .option("delimiter", delimiter) \
        .save(file)

# sink HDFS
def sinkHDFS(sinkDF, path, delimiter, format="parquet", mode=Constants.SAVE_MODE_OVERWRITE):
    sinkDF\
        .write\
        .format(format) \
        .option("delimiter", delimiter) \
        .option("quote", '"') \
        .mode(mode)\
        .save(path)

# 修改 MySQL 状态
def updateMysqlStatus(i_status, i_readcount, i_sinkcount, i_id):
    try:
        conn = Sources.getMySqlConnect()
        # 创建游标对象,用来给数据库发送sql语句
        cur = conn.cursor()
        serch_data = """update uptable set status={status}, readcount={readcount}, sinkcount={sinkcount} where id = {id}"""\
            .format(status=i_status, readcount=i_readcount, sinkcount=i_sinkcount, id=i_id)
        result = cur.execute(serch_data)
    except ex.MyError as e:
        print("update error", e.errorinfo)
    finally:
        cur.close()  # 关闭数据库连接
        conn.close()