import pymysql
import exception.MyErrorException as ex
from pyspark import SparkContext
from sources import Sinks


def getMySqlConnect():
    try:
        # 连接数据库
        conn = pymysql.connect(
            host="hadoop1",  # 连接主机名,也可以用ip地址，例如127.0.0.1
            user="root",  # 连接用户名
            passwd="123",  # 用户密码
            db="wanjia",  # 要连接的数据库名
            charset="utf8",  # 指定编码格式
            autocommit=True,  # 如果插入数据，， 是否自动提交? 和conn.commit()功能一致。
        )
    except ex.MyError as e:
        print("connection error", e.errorinfo)
        Sinks.updateMysqlStatus(i_status=1, i_readcount=0, i_sinkcount=0, i_id=1)
    return conn


def getRecordByIdResultT1(id):
    conn = getMySqlConnect()
    # 创建游标对象,用来给数据库发送sql语句
    try:
        cur = conn.cursor()
        serch_data = """select t1 from test where id = {table_id}""".format(table_id=id)
        result = cur.execute(serch_data)
        # 获取下一个查询结果集
        record = cur.fetchone()
    except ex.MyError as e:
        Sinks.updateMysqlStatus(i_status=1, i_readcount=0, i_sinkcount=0, i_id=1)
        print("executor failed", e.errorinfo)
        conn.rollback()
    finally:
        cur.close()  # 关闭数据库连接
        conn.close()
    return record


def readCsv(spark, path, col):
    try:
        df = spark.read.format('csv').option('inferSchema', 'true').load(path).toDF(*col)
    except ex.MyError as e:
        Sinks.updateMysqlStatus(i_status=1, i_readcount=0, i_sinkcount=0, i_id=1)
        print("executor failed", e.errorinfo)
    return df


def readTxt(spark, path, delimiter, *col):
    try:
        rddFile = SparkContext.textFile(path)
        rddMap = rddFile.map(lambda x: x.split(delimiter))
        df = spark.createDataFrame(rddMap, *col)
    except ex.MyError as e:
        Sinks.updateMysqlStatus(i_status=1, i_readcount=0, i_sinkcount=0, i_id=1)
        print("executor failed", e.errorinfo)
    return df